<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>physicallayer/nettypes.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">physicallayer/nettypes.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2005 by Christian Van Brussel</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PL_NETTYPES__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PL_NETTYPES__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/csstring_8h.html">csutil/csstring.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/bitarray_8h.html">csutil/bitarray.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;physicallayer/persist.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;physicallayer/entity.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;celtool/persisthelper.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">struct </span><a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>;
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classcelGameInfoList.html" title="A list of general info of games.">celGameInfoList</a>;
<a name="l00034"></a>00034 <span class="keyword">struct </span>celGameInfoListIterator;
<a name="l00035"></a>00035 <span class="keyword">struct </span><a class="code" href="structiCelGameServer.html" title="The main object to manage the server game logic.">iCelGameServer</a>;
<a name="l00036"></a>00036 <span class="keyword">struct </span><a class="code" href="structiCelGameClient.html" title="The main object to manage the client game logic.">iCelGameClient</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsBitArray.html">csBitArray</a>;
<a name="l00038"></a>00038 <span class="keyword">struct </span>celPlayerListIterator;
<a name="l00039"></a>00039 
<a name="l00048"></a>00048 <span class="keyword">enum</span> celNetworkGameType
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   CEL_NET_UNDEF = 0,
<a name="l00051"></a>00051   CEL_NET_SINGLEPLAYER,
<a name="l00052"></a>00052   CEL_NET_LOCAL,
<a name="l00053"></a>00053   CEL_NET_PUBLIC,
<a name="l00054"></a>00054   CEL_NET_PLAYBACK
<a name="l00055"></a>00055 };
<a name="l00056"></a>00056 
<a name="l00058"></a>00058 <span class="comment">// TODO: these types must be changed if there are more than 256 values</span>
<a name="l00059"></a>00059 <span class="keyword">typedef</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga33a5e996e7a90acefb8b1c0bea47e365">uint8</a> celClientEventType;
<a name="l00060"></a>00060 <span class="keyword">typedef</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga33a5e996e7a90acefb8b1c0bea47e365">uint8</a> celServerEventType;
<a name="l00061"></a>00061 <span class="keyword">typedef</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga33a5e996e7a90acefb8b1c0bea47e365">uint8</a> celNetworkLinkType;
<a name="l00062"></a>00062 
<a name="l00078"></a>00078 <span class="keyword">enum</span> celPlayerNetworkState
<a name="l00079"></a>00079 {
<a name="l00080"></a>00080   CEL_NET_PLAYER_UNDEF = 0,
<a name="l00081"></a>00081   CEL_NET_PLAYER_NOT_CONNECTED,
<a name="l00082"></a>00082   CEL_NET_PLAYER_CONNECTING,
<a name="l00083"></a>00083   CEL_NET_PLAYER_PLAYING,
<a name="l00084"></a>00084   CEL_NET_PLAYER_DISCONNECTED,
<a name="l00085"></a>00085   CEL_NET_PLAYER_UNREACHABLE,
<a name="l00086"></a>00086   CEL_NET_PLAYER_LOST
<a name="l00087"></a>00087 };
<a name="l00088"></a>00088 
<a name="l00122"></a>00122 <span class="keyword">enum</span> celServerNetworkState
<a name="l00123"></a>00123 {
<a name="l00124"></a>00124   CEL_NET_SERVER_UNDEF = 0,
<a name="l00125"></a>00125   CEL_NET_SERVER_NOT_CONNECTED,
<a name="l00126"></a>00126   CEL_NET_SERVER_INVALID_HOSTNAME,
<a name="l00127"></a>00127   CEL_NET_SERVER_TRYING_CONNECTION,
<a name="l00128"></a>00128   CEL_NET_SERVER_CONNECTING,
<a name="l00129"></a>00129   CEL_NET_SERVER_REJECTED_BAD_GAME,
<a name="l00130"></a>00130   CEL_NET_SERVER_REJECTED_BAD_PROTOCOL,
<a name="l00131"></a>00131   CEL_NET_SERVER_REJECTED_BAD_PASSWORD,
<a name="l00132"></a>00132   CEL_NET_SERVER_REJECTED_SINGLEPLAYER,
<a name="l00133"></a>00133   CEL_NET_SERVER_REJECTED_UNAUTHORIZED,
<a name="l00134"></a>00134   CEL_NET_SERVER_REJECTED_MAX_PLAYERS,
<a name="l00135"></a>00135   CEL_NET_SERVER_LOADING_DATA,
<a name="l00136"></a>00136   CEL_NET_SERVER_PLAYING,
<a name="l00137"></a>00137   CEL_NET_SERVER_DISCONNECTED,
<a name="l00138"></a>00138   CEL_NET_SERVER_UNREACHABLE,
<a name="l00139"></a>00139   CEL_NET_SERVER_LOST,
<a name="l00140"></a>00140   CEL_NET_SERVER_KICKED
<a name="l00141"></a>00141 };
<a name="l00142"></a>00142 
<a name="l00146"></a><a class="code" href="classcelGameInfo.html">00146</a> <span class="keyword">class </span><a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>
<a name="l00147"></a>00147 {
<a name="l00148"></a>00148  <span class="keyword">public</span>:
<a name="l00150"></a><a class="code" href="classcelGameInfo.html#a98f2200b0c48cb5e7791312490f39c72">00150</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a> <a class="code" href="classcelGameInfo.html#a98f2200b0c48cb5e7791312490f39c72" title="The ID of the game.">game_id</a>;
<a name="l00151"></a>00151 
<a name="l00153"></a><a class="code" href="classcelGameInfo.html#a8fdc6cf0e4edbf743698e9944c2a2ad2">00153</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> <a class="code" href="classcelGameInfo.html#a8fdc6cf0e4edbf743698e9944c2a2ad2" title="The name of the game.">game_name</a>;
<a name="l00154"></a>00154 
<a name="l00156"></a><a class="code" href="classcelGameInfo.html#a79f4b8e8e7facaa7ec70d45171e7b35b">00156</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> <a class="code" href="classcelGameInfo.html#a79f4b8e8e7facaa7ec70d45171e7b35b" title="The hostname of the server if available.">hostname</a>;
<a name="l00157"></a>00157 
<a name="l00159"></a><a class="code" href="classcelGameInfo.html#a347f8d21268caac0e83291055a13d8a9">00159</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga33a5e996e7a90acefb8b1c0bea47e365">uint8</a> <a class="code" href="classcelGameInfo.html#a347f8d21268caac0e83291055a13d8a9" title="The IP address of the game/server, large enough to hold IPv6 address.">ip_address</a>[32];
<a name="l00160"></a>00160 
<a name="l00162"></a><a class="code" href="classcelGameInfo.html#af518a5c71c34eafe567528148ce946ea">00162</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gac2a9e79eb120216f855626495b7bd18a">uint16</a> <a class="code" href="classcelGameInfo.html#af518a5c71c34eafe567528148ce946ea" title="The port number of the server.">port_nb</a>;
<a name="l00163"></a>00163 
<a name="l00165"></a><a class="code" href="classcelGameInfo.html#a0b968488bd556e5f08fe5114b91f439d">00165</a>   <span class="keywordtype">size_t</span> <a class="code" href="classcelGameInfo.html#a0b968488bd556e5f08fe5114b91f439d" title="The maximum number of players for this game.">max_players</a>;
<a name="l00166"></a>00166 
<a name="l00168"></a><a class="code" href="classcelGameInfo.html#a393d01f31c1ee418a584806e8fa876e5">00168</a>   <span class="keywordtype">size_t</span> <a class="code" href="classcelGameInfo.html#a393d01f31c1ee418a584806e8fa876e5" title="The current number of players.">current_num_players</a>;
<a name="l00169"></a>00169 
<a name="l00171"></a><a class="code" href="classcelGameInfo.html#a59e83f3d5f6e42f64190140fcff5cafa">00171</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> <a class="code" href="classcelGameInfo.html#a59e83f3d5f6e42f64190140fcff5cafa" title="The password needed to connect to the game.">password</a>;
<a name="l00172"></a>00172 
<a name="l00177"></a><a class="code" href="classcelGameInfo.html#aee7a69dde9cf6d01aa75fa1cf9428372">00177</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iCelDataBuffer&gt;</a> <a class="code" href="classcelGameInfo.html#aee7a69dde9cf6d01aa75fa1cf9428372" title="Some custom data specific to the application.">custom_data</a>;
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a> ()
<a name="l00180"></a>00180   {
<a name="l00181"></a>00181     <a class="code" href="classcelGameInfo.html#a98f2200b0c48cb5e7791312490f39c72" title="The ID of the game.">game_id</a> = 0;
<a name="l00182"></a>00182     memset (<a class="code" href="classcelGameInfo.html#a347f8d21268caac0e83291055a13d8a9" title="The IP address of the game/server, large enough to hold IPv6 address.">ip_address</a>, 0, 32);
<a name="l00183"></a>00183     <a class="code" href="classcelGameInfo.html#af518a5c71c34eafe567528148ce946ea" title="The port number of the server.">port_nb</a> = 0;
<a name="l00184"></a>00184     <a class="code" href="classcelGameInfo.html#a0b968488bd556e5f08fe5114b91f439d" title="The maximum number of players for this game.">max_players</a> = 0;
<a name="l00185"></a>00185     <a class="code" href="classcelGameInfo.html#a393d01f31c1ee418a584806e8fa876e5" title="The current number of players.">current_num_players</a> = 0;
<a name="l00186"></a>00186     <a class="code" href="classcelGameInfo.html#aee7a69dde9cf6d01aa75fa1cf9428372" title="Some custom data specific to the application.">custom_data</a> = 0;
<a name="l00187"></a>00187   }
<a name="l00188"></a>00188 
<a name="l00192"></a>00192   <span class="keywordtype">bool</span> <a class="code" href="classcelGameInfo.html#a7656bd23a74fccfa2687cca1b800c20e" title="Return true if this game info matches the filter, false otherwise.">MatchFilter</a> (<a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* filter);
<a name="l00193"></a>00193 
<a name="l00200"></a>00200   <span class="keywordtype">int</span> <a class="code" href="classcelGameInfo.html#a01be8a4fd913b79956a143fa6e5a5cc9" title="Return 0 if this game info is equal to the other, a negative value if it is smaller, and a positive value if it is bigger.">Compare</a> (<a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* other, <a class="code" href="classcelGameInfoList.html" title="A list of general info of games.">celGameInfoList</a>* filters);
<a name="l00201"></a>00201 };
<a name="l00202"></a>00202 
<a name="l00206"></a><a class="code" href="classcelGameInfoList.html">00206</a> <span class="keyword">class </span><a class="code" href="classcelGameInfoList.html" title="A list of general info of games.">celGameInfoList</a>
<a name="l00207"></a>00207 {
<a name="l00208"></a>00208  <span class="keyword">public</span>:
<a name="l00209"></a>00209   <span class="keyword">virtual</span> ~<a class="code" href="classcelGameInfoList.html" title="A list of general info of games.">celGameInfoList</a> () = 0;
<a name="l00210"></a>00210   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> GetCount () <span class="keyword">const</span> = 0;
<a name="l00211"></a>00211   <span class="keyword">virtual</span> <a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* Get (<span class="keywordtype">size_t</span> index) <span class="keyword">const</span> = 0;
<a name="l00212"></a>00212   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> Add (<a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* player) = 0;
<a name="l00213"></a>00213   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> Remove (<a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* player) = 0;
<a name="l00214"></a>00214   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> Remove (<span class="keywordtype">size_t</span> n) = 0;
<a name="l00215"></a>00215   <span class="keyword">virtual</span> <span class="keywordtype">void</span> RemoveAll () = 0;
<a name="l00216"></a>00216   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> Find (<a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* player) <span class="keyword">const</span> = 0;
<a name="l00217"></a>00217 
<a name="l00222"></a>00222   <span class="keywordtype">void</span> <a class="code" href="classcelGameInfoList.html#a5e95411e97f43599e0f83cc3f1b540ab" title="Filter the list of games.">Filter</a> (<a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* game_info);
<a name="l00223"></a>00223 
<a name="l00228"></a>00228   <span class="keywordtype">void</span> <a class="code" href="classcelGameInfoList.html#ab96c40a58f9265dbc2985a595e5073d6" title="Sort the list of games.">Sort</a> (<a class="code" href="classcelGameInfoList.html" title="A list of general info of games.">celGameInfoList</a>* filters);
<a name="l00229"></a>00229 };
<a name="l00230"></a>00230 
<a name="l00234"></a><a class="code" href="classcelPlayer.html">00234</a> <span class="keyword">class </span><a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>
<a name="l00235"></a>00235 {
<a name="l00236"></a>00236  <span class="keyword">public</span>:
<a name="l00237"></a>00237   <span class="keyword">virtual</span> ~<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a> () {}
<a name="l00238"></a>00238 
<a name="l00240"></a><a class="code" href="classcelPlayer.html#a5459b82d64e51492096744336f204041">00240</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a> <a class="code" href="classcelPlayer.html#a5459b82d64e51492096744336f204041" title="The ID of the player.">player_id</a>;
<a name="l00241"></a>00241 
<a name="l00243"></a><a class="code" href="classcelPlayer.html#a6d84ed9b5c9a1986a8a9f96941c6d7a3">00243</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> <a class="code" href="classcelPlayer.html#a6d84ed9b5c9a1986a8a9f96941c6d7a3" title="The name of the player.">player_name</a>;
<a name="l00244"></a>00244 
<a name="l00246"></a><a class="code" href="classcelPlayer.html#aec44e212713818dbc96110753da2b2af">00246</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> <a class="code" href="classcelPlayer.html#aec44e212713818dbc96110753da2b2af" title="The hostname of the player if available.">hostname</a>;
<a name="l00247"></a>00247 
<a name="l00249"></a><a class="code" href="classcelPlayer.html#a4dcd83e821a7e6d9f8d6214e4432e583">00249</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga33a5e996e7a90acefb8b1c0bea47e365">uint8</a> <a class="code" href="classcelPlayer.html#a4dcd83e821a7e6d9f8d6214e4432e583" title="The IP address of the game/player, large enough to hold IPv6 address.">ip_address</a>[32];
<a name="l00250"></a>00250 
<a name="l00252"></a><a class="code" href="classcelPlayer.html#a437c0e87e7e8e84b0ea36aab4636d5fb">00252</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gac2a9e79eb120216f855626495b7bd18a">uint16</a> <a class="code" href="classcelPlayer.html#a437c0e87e7e8e84b0ea36aab4636d5fb" title="The port number of the player.">port_nb</a>;
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a> ()
<a name="l00255"></a>00255   {
<a name="l00256"></a>00256     <a class="code" href="classcelPlayer.html#a5459b82d64e51492096744336f204041" title="The ID of the player.">player_id</a> = 0;
<a name="l00257"></a>00257     memset (<a class="code" href="classcelPlayer.html#a4dcd83e821a7e6d9f8d6214e4432e583" title="The IP address of the game/player, large enough to hold IPv6 address.">ip_address</a>, 0, 32);
<a name="l00258"></a>00258     <a class="code" href="classcelPlayer.html#a437c0e87e7e8e84b0ea36aab4636d5fb" title="The port number of the player.">port_nb</a> = 0;
<a name="l00259"></a>00259   }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   <span class="keywordtype">bool</span> operator == (<span class="keyword">const</span> <a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>&amp; other)<span class="keyword"> const</span>
<a name="l00262"></a>00262 <span class="keyword">  </span>{
<a name="l00263"></a>00263     <span class="keywordflow">return</span> <a class="code" href="classcelPlayer.html#aec44e212713818dbc96110753da2b2af" title="The hostname of the player if available.">hostname</a>.<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsStringBase.html#aa69d6ead2eaf3d8b16988c23120aefbc">Compare</a>(other.<a class="code" href="classcelPlayer.html#aec44e212713818dbc96110753da2b2af" title="The hostname of the player if available.">hostname</a>) &amp;&amp; <a class="code" href="classcelPlayer.html#a437c0e87e7e8e84b0ea36aab4636d5fb" title="The port number of the player.">port_nb</a> == other.<a class="code" href="classcelPlayer.html#a437c0e87e7e8e84b0ea36aab4636d5fb" title="The port number of the player.">port_nb</a>;
<a name="l00264"></a>00264   }
<a name="l00265"></a>00265 
<a name="l00266"></a>00266   <span class="keywordtype">void</span> PrintDebugInfo ()
<a name="l00267"></a>00267   {
<a name="l00268"></a>00268     printf(<span class="stringliteral">&quot;Player data:\n&quot;</span>);
<a name="l00269"></a>00269     printf(<span class="stringliteral">&quot;\tID: %d\n&quot;</span>, <a class="code" href="classcelPlayer.html#a5459b82d64e51492096744336f204041" title="The ID of the player.">player_id</a>);
<a name="l00270"></a>00270     printf(<span class="stringliteral">&quot;\tname: %s\n&quot;</span>, <a class="code" href="classcelPlayer.html#a6d84ed9b5c9a1986a8a9f96941c6d7a3" title="The name of the player.">player_name</a>.<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsStringFast.html#aae377ba228b98ff910c5508f320c0d75">GetData</a>());
<a name="l00271"></a>00271     printf(<span class="stringliteral">&quot;\thostname: %s\n&quot;</span>, <a class="code" href="classcelPlayer.html#aec44e212713818dbc96110753da2b2af" title="The hostname of the player if available.">hostname</a>.<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsStringFast.html#aae377ba228b98ff910c5508f320c0d75">GetData</a>());
<a name="l00272"></a>00272     printf(<span class="stringliteral">&quot;\taddress: &quot;</span>);
<a name="l00273"></a>00273     <span class="keywordtype">int</span> i = 0;
<a name="l00274"></a>00274     <span class="keywordflow">for</span> ( ; i &lt; 32; i++)
<a name="l00275"></a>00275       printf(<span class="stringliteral">&quot;%d&quot;</span>, <a class="code" href="classcelPlayer.html#a4dcd83e821a7e6d9f8d6214e4432e583" title="The IP address of the game/player, large enough to hold IPv6 address.">ip_address</a>[i]);
<a name="l00276"></a>00276     printf(<span class="stringliteral">&quot;\n&quot;</span>);
<a name="l00277"></a>00277     <span class="comment">// TODO: print in IPv6 notation</span>
<a name="l00278"></a>00278     <span class="comment">/*</span>
<a name="l00279"></a>00279 <span class="comment">    printf(&quot;\taddress: &quot;);</span>
<a name="l00280"></a>00280 <span class="comment">    i = 0;</span>
<a name="l00281"></a>00281 <span class="comment">    for ( ; i &lt; 32; i++)</span>
<a name="l00282"></a>00282 <span class="comment">      printf(&quot;%X-&quot;, ip_address[i]);</span>
<a name="l00283"></a>00283 <span class="comment">    printf(&quot;\n&quot;);</span>
<a name="l00284"></a>00284 <span class="comment">    */</span>
<a name="l00285"></a>00285     printf(<span class="stringliteral">&quot;\tport: %d\n&quot;</span>, <a class="code" href="classcelPlayer.html#a437c0e87e7e8e84b0ea36aab4636d5fb" title="The port number of the player.">port_nb</a>);
<a name="l00286"></a>00286   }
<a name="l00287"></a>00287 };
<a name="l00288"></a>00288 
<a name="l00292"></a><a class="code" href="structiCelPlayerList.html">00292</a> <span class="keyword">struct </span><a class="code" href="structiCelPlayerList.html" title="A list of players.">iCelPlayerList</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00293"></a>00293 {
<a name="l00294"></a>00294   SCF_INTERFACE (<a class="code" href="structiCelPlayerList.html" title="A list of players.">iCelPlayerList</a>, 0, 0, 1);
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> GetCount () <span class="keyword">const</span> = 0;
<a name="l00297"></a>00297   <span class="keyword">virtual</span> <a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* Get (<span class="keywordtype">size_t</span> index) <span class="keyword">const</span> = 0;
<a name="l00298"></a>00298   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> Add (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player) = 0;
<a name="l00299"></a>00299   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> Remove (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player) = 0;
<a name="l00300"></a>00300   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> Remove (<span class="keywordtype">size_t</span> n) = 0;
<a name="l00301"></a>00301   <span class="keyword">virtual</span> <span class="keywordtype">void</span> RemoveAll () = 0;
<a name="l00302"></a>00302   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> Find (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player) <span class="keyword">const</span> = 0;
<a name="l00303"></a>00303   <span class="comment">//virtual bool Contains (celPlayer* player) = 0;</span>
<a name="l00304"></a>00304 };
<a name="l00305"></a>00305 
<a name="l00309"></a><a class="code" href="classcelServerEventData.html">00309</a> <span class="keyword">class </span><a class="code" href="classcelServerEventData.html" title="The data about a server event.">celServerEventData</a>
<a name="l00310"></a>00310 {
<a name="l00311"></a>00311  <span class="keyword">public</span>:
<a name="l00315"></a><a class="code" href="classcelServerEventData.html#abcc2d43b53e5e4862ec0a4d5070e9020">00315</a>   celServerEventType <a class="code" href="classcelServerEventData.html#abcc2d43b53e5e4862ec0a4d5070e9020" title="The type of the event.">event_type</a>;
<a name="l00316"></a>00316 
<a name="l00320"></a><a class="code" href="classcelServerEventData.html#a695febda18615266943e9552c64c06bb">00320</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> <a class="code" href="classcelServerEventData.html#a695febda18615266943e9552c64c06bb" title="The time at which the event occured.">event_time</a>;
<a name="l00321"></a>00321 
<a name="l00325"></a><a class="code" href="classcelServerEventData.html#ade3009c7299b5e63226bfbbf8df8cc91">00325</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iCelDataBuffer&gt;</a> <a class="code" href="classcelServerEventData.html#ade3009c7299b5e63226bfbbf8df8cc91" title="The persistent data of the event.">event_data</a>;
<a name="l00326"></a>00326 
<a name="l00331"></a><a class="code" href="classcelServerEventData.html#a46ae665e0029280f6bcf27fdb18acebe">00331</a>   <span class="keywordtype">bool</span> <a class="code" href="classcelServerEventData.html#a46ae665e0029280f6bcf27fdb18acebe" title="True if we need to be sure that the message has been received by the client.">reliable</a>;
<a name="l00332"></a>00332 };
<a name="l00333"></a>00333 
<a name="l00337"></a><a class="code" href="classcelClientEventData.html">00337</a> <span class="keyword">class </span><a class="code" href="classcelClientEventData.html" title="The data about a client event.">celClientEventData</a>
<a name="l00338"></a>00338 {
<a name="l00339"></a>00339  <span class="keyword">public</span>:
<a name="l00343"></a><a class="code" href="classcelClientEventData.html#a4241fb7084767b9acd9c75d2c0734abe">00343</a>   celClientEventType <a class="code" href="classcelClientEventData.html#a4241fb7084767b9acd9c75d2c0734abe" title="The type of the event.">event_type</a>;
<a name="l00344"></a>00344 
<a name="l00348"></a><a class="code" href="classcelClientEventData.html#a8682bdcd4984245a84ce4460ca4d4be6">00348</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> <a class="code" href="classcelClientEventData.html#a8682bdcd4984245a84ce4460ca4d4be6" title="The time at which the event occured.">event_time</a>;
<a name="l00349"></a>00349 
<a name="l00353"></a><a class="code" href="classcelClientEventData.html#a9a1d6e48fb5769ec5142617832c9152c">00353</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iCelDataBuffer&gt;</a> <a class="code" href="classcelClientEventData.html#a9a1d6e48fb5769ec5142617832c9152c" title="The persistent data of the event.">event_data</a>;
<a name="l00354"></a>00354 
<a name="l00358"></a><a class="code" href="classcelClientEventData.html#a02e072cc175bd325a9136e217af1a9ac">00358</a>   <span class="keywordtype">bool</span> <a class="code" href="classcelClientEventData.html#a02e072cc175bd325a9136e217af1a9ac" title="True if we need to be sure that the message has been received by the server.">reliable</a>;
<a name="l00359"></a>00359 
<a name="l00360"></a>00360   <a class="code" href="classcelClientEventData.html" title="The data about a client event.">celClientEventData</a> () :
<a name="l00361"></a>00361     <a class="code" href="classcelClientEventData.html#a4241fb7084767b9acd9c75d2c0734abe" title="The type of the event.">event_type</a> (0),
<a name="l00362"></a>00362     <a class="code" href="classcelClientEventData.html#a8682bdcd4984245a84ce4460ca4d4be6" title="The time at which the event occured.">event_time</a> (0),
<a name="l00363"></a>00363     <a class="code" href="classcelClientEventData.html#a9a1d6e48fb5769ec5142617832c9152c" title="The persistent data of the event.">event_data</a> (0),
<a name="l00364"></a>00364     <a class="code" href="classcelClientEventData.html#a02e072cc175bd325a9136e217af1a9ac" title="True if we need to be sure that the message has been received by the server.">reliable</a> (true)
<a name="l00365"></a>00365     {}
<a name="l00366"></a>00366 
<a name="l00367"></a>00367   <a class="code" href="classcelClientEventData.html" title="The data about a client event.">celClientEventData</a> (<a class="code" href="classcelClientEventData.html" title="The data about a client event.">celClientEventData</a> &amp;event) :
<a name="l00368"></a>00368     <a class="code" href="classcelClientEventData.html#a4241fb7084767b9acd9c75d2c0734abe" title="The type of the event.">event_type</a> (event.<a class="code" href="classcelClientEventData.html#a4241fb7084767b9acd9c75d2c0734abe" title="The type of the event.">event_type</a>),
<a name="l00369"></a>00369     <a class="code" href="classcelClientEventData.html#a8682bdcd4984245a84ce4460ca4d4be6" title="The time at which the event occured.">event_time</a> (event.<a class="code" href="classcelClientEventData.html#a8682bdcd4984245a84ce4460ca4d4be6" title="The time at which the event occured.">event_time</a>),
<a name="l00370"></a>00370     <a class="code" href="classcelClientEventData.html#a9a1d6e48fb5769ec5142617832c9152c" title="The persistent data of the event.">event_data</a> (event.<a class="code" href="classcelClientEventData.html#a9a1d6e48fb5769ec5142617832c9152c" title="The persistent data of the event.">event_data</a>),
<a name="l00371"></a>00371     <a class="code" href="classcelClientEventData.html#a02e072cc175bd325a9136e217af1a9ac" title="True if we need to be sure that the message has been received by the server.">reliable</a> (event.<a class="code" href="classcelClientEventData.html#a02e072cc175bd325a9136e217af1a9ac" title="True if we need to be sure that the message has been received by the server.">reliable</a>)
<a name="l00372"></a>00372     {}
<a name="l00373"></a>00373 };
<a name="l00374"></a>00374 
<a name="l00378"></a><a class="code" href="classcelNetworkLinkData.html">00378</a> <span class="keyword">class </span><a class="code" href="classcelNetworkLinkData.html" title="The data about a network link.">celNetworkLinkData</a>
<a name="l00379"></a>00379 {
<a name="l00380"></a>00380  <span class="keyword">public</span>:
<a name="l00384"></a><a class="code" href="classcelNetworkLinkData.html#a8024f2bdb503a6ad30a4dc70734ab7aa">00384</a>   celNetworkLinkType <a class="code" href="classcelNetworkLinkData.html#a8024f2bdb503a6ad30a4dc70734ab7aa" title="The type of the source of the network link.">link_type</a>;
<a name="l00385"></a>00385 
<a name="l00389"></a><a class="code" href="classcelNetworkLinkData.html#a91175864af367acedbb3164d613a867d">00389</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iCelEntity&gt;</a> <a class="code" href="classcelNetworkLinkData.html#a91175864af367acedbb3164d613a867d" title="The source of the network link.">linked_entity</a>;
<a name="l00390"></a>00390 
<a name="l00394"></a><a class="code" href="classcelNetworkLinkData.html#a4c84dd65258bc2dc67625b007a99b151">00394</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsBitArray.html">csBitArray</a> <a class="code" href="classcelNetworkLinkData.html#a4c84dd65258bc2dc67625b007a99b151" title="A mask to select needed fields of the persistent data that will be sent.">persistence_mask</a>;
<a name="l00395"></a>00395 
<a name="l00401"></a><a class="code" href="classcelNetworkLinkData.html#ad8f37a12aa1372769930329382037cfe">00401</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> <a class="code" href="classcelNetworkLinkData.html#ad8f37a12aa1372769930329382037cfe" title="The time period between the sending of updates.">period</a>;
<a name="l00402"></a>00402 
<a name="l00403"></a>00403   <a class="code" href="classcelNetworkLinkData.html" title="The data about a network link.">celNetworkLinkData</a> () {}
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   <a class="code" href="classcelNetworkLinkData.html" title="The data about a network link.">celNetworkLinkData</a> (celNetworkLinkType _link_type, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* _linked_entity,
<a name="l00406"></a>00406                       <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsBitArray.html">csBitArray</a> _persistence_mask, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> _period) :
<a name="l00407"></a>00407     <a class="code" href="classcelNetworkLinkData.html#a8024f2bdb503a6ad30a4dc70734ab7aa" title="The type of the source of the network link.">link_type</a> (_link_type),
<a name="l00408"></a>00408     <a class="code" href="classcelNetworkLinkData.html#a91175864af367acedbb3164d613a867d" title="The source of the network link.">linked_entity</a> (_linked_entity),
<a name="l00409"></a>00409     <a class="code" href="classcelNetworkLinkData.html#a4c84dd65258bc2dc67625b007a99b151" title="A mask to select needed fields of the persistent data that will be sent.">persistence_mask</a> (_persistence_mask),
<a name="l00410"></a>00410     <a class="code" href="classcelNetworkLinkData.html#ad8f37a12aa1372769930329382037cfe" title="The time period between the sending of updates.">period</a> (_period)
<a name="l00411"></a>00411     {}
<a name="l00412"></a>00412 
<a name="l00413"></a>00413   ~<a class="code" href="classcelNetworkLinkData.html" title="The data about a network link.">celNetworkLinkData</a> () {}
<a name="l00414"></a>00414 };
<a name="l00415"></a>00415 
<a name="l00420"></a><a class="code" href="structcelNetworkServerStats.html">00420</a> <span class="keyword">struct </span><a class="code" href="structcelNetworkServerStats.html" title="The network stats of the connection viewed by the client.">celNetworkServerStats</a>
<a name="l00421"></a>00421 {
<a name="l00422"></a>00422   <span class="comment">// The latency of the network transmission to the player</span>
<a name="l00423"></a>00423   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> latency;
<a name="l00424"></a>00424   <span class="comment">// The state of the connection</span>
<a name="l00425"></a>00425   celServerNetworkState network_state;
<a name="l00426"></a>00426   <span class="comment">// Instant flow of the data sent by the client, in bytes per second</span>
<a name="l00427"></a>00427   <span class="keywordtype">size_t</span> incoming_bandwidth;
<a name="l00428"></a>00428   <span class="comment">// Instant flow of the data sent by the server to this client, in bytes</span>
<a name="l00429"></a>00429   <span class="comment">// per second</span>
<a name="l00430"></a>00430   <span class="keywordtype">size_t</span> outgoing_bandwidth;
<a name="l00431"></a>00431 };
<a name="l00432"></a>00432 
<a name="l00437"></a><a class="code" href="structcelNetworkPlayerStats.html">00437</a> <span class="keyword">struct </span><a class="code" href="structcelNetworkPlayerStats.html" title="The network stats of the connection viewed by the server.">celNetworkPlayerStats</a>
<a name="l00438"></a>00438 {
<a name="l00439"></a>00439   <span class="comment">// The latency of the network transmission to the player</span>
<a name="l00440"></a>00440   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> latency;
<a name="l00441"></a>00441   <span class="comment">// Instant flow of the data sent by the client, in bytes per second</span>
<a name="l00442"></a>00442   <span class="keywordtype">size_t</span> incoming_bandwidth;
<a name="l00443"></a>00443   <span class="comment">// Instant flow of the data sent by the server to this client, in bytes</span>
<a name="l00444"></a>00444   <span class="comment">// per second</span>
<a name="l00445"></a>00445   <span class="keywordtype">size_t</span> outgoing_bandwidth;
<a name="l00446"></a>00446 };
<a name="l00447"></a>00447 
<a name="l00452"></a><a class="code" href="structcelNetworkPlayerTotalStats.html">00452</a> <span class="keyword">struct </span><a class="code" href="structcelNetworkPlayerTotalStats.html" title="The network stats of the connection of all the players viewed by the server.">celNetworkPlayerTotalStats</a>
<a name="l00453"></a>00453 {
<a name="l00454"></a>00454   <span class="comment">// Instant flow of all the data sent by the clients, in bytes per second</span>
<a name="l00455"></a>00455   <span class="keywordtype">size_t</span> total_incoming_bandwidth;
<a name="l00456"></a>00456   <span class="comment">// Instant flow of all the data sent by the server to the clients, in bytes</span>
<a name="l00457"></a>00457   <span class="comment">// per second</span>
<a name="l00458"></a>00458   <span class="keywordtype">size_t</span> total_outgoing_bandwidth;
<a name="l00459"></a>00459 };
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 <span class="preprocessor">#endif // __CEL_PL_NETTYPES__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
